DayTimeMoneyHud = {};
DayTimeMoneyHud.metadata = {
	interface = " FS19 ...",
	title = " DayTimeMoney Hud",
	notes = " setzt GameDay/RealDay/RealTime+Color zusätzlich/mit ins DayTimeMoney Hud",
	author = " (by HappyLooser)",
	version = " v0.1 Beta",	
	datum = " 20.11.2018",
	update = " 28.11.2018",
	web = " no",
	info = " Link Freigabe,Änderungen,Kopien oder Code Benutzung ist ohne meine Zustimmung nicht erlaubt",
	"##Orginal Link Freigabe:"
};


function DayTimeMoneyHud:loadMap(name)
	if g_currentMission.DayTimeMoneyHud == nil then g_currentMission.DayTimeMoneyHud = true;end;
	print("---loading".. tostring(DayTimeMoneyHud.metadata.title).. tostring(DayTimeMoneyHud.metadata.version).. tostring(DayTimeMoneyHud.metadata.author).. "---")
	
	DayTimeMoneyHud.settingsDir = getUserProfileAppPath().. "modsSettings/DayTimeMoneyHud/";
	if g_server ~= nil and g_client == nil then return;end;
	DayTimeMoneyHud.inGameDay = {true, 0.010, 1};
	DayTimeMoneyHud.inGameDayColor = {1, 1, 1, 1};
	DayTimeMoneyHud.playDay = {true, 0.010, 1};
	DayTimeMoneyHud.playDayColor = {1, 1, 1, 1};
	DayTimeMoneyHud.realDay = {true, 0.010, 1};
	DayTimeMoneyHud.realDayColor = {0.870588, 0.007843, 0.011764, 1};
	DayTimeMoneyHud.inGameTime = {true, 0.010, 1};	
	DayTimeMoneyHud.inGameTimeColor = {1, 1, 1, 1};
	DayTimeMoneyHud.realTime = {true, 0.010, 1};
	DayTimeMoneyHud.realTimeColor = {0.870588, 0.007843, 0.011764, 1};
	DayTimeMoneyHud.inGame = nil;
	DayTimeMoneyHud:getInGameDisplay();
	DayTimeMoneyHud.language = {"Montag", "Dienstag", "Mittwoch", "Donnerstag", "Freitag", "Samstag", "Sonntag", "Spieltag:"};
	if DayTimeMoneyHud.inGame ~= nil and DayTimeMoneyHud.inGame.timeTextSize ~= nil then DayTimeMoneyHud.inGameTime[2] = DayTimeMoneyHud.inGame.timeTextSize;end;	
	DayTimeMoneyHud:setGetCfg(true);	
end;

function DayTimeMoneyHud:deleteMap()
	if g_server ~= nil and g_client == nil then return;end;
	DayTimeMoneyHud:setGetCfg(false);	
end;

function DayTimeMoneyHud:mouseEvent(posX, posY, isDown, isUp, button)
end;

function DayTimeMoneyHud:keyEvent(unicode, sym, modifier, isDown)	
end;

function DayTimeMoneyHud:update(dt)
end;

function DayTimeMoneyHud:draw(dt)
	if g_server ~= nil and g_client == nil then return;end;
	if DayTimeMoneyHud.playDay[1] or DayTimeMoneyHud.inGameDay[1] then
		local playDayString = ""; 
		local playDay = DayTimeMoneyHud.language[8] .." ".. DayTimeMoneyHud:getInGameDay(true, false)
		local inGameDay = DayTimeMoneyHud.language[DayTimeMoneyHud:getInGameDay(false, true)];
		local size = DayTimeMoneyHud.playDay[2];
		local color = DayTimeMoneyHud.playDayColor;
		if DayTimeMoneyHud.playDay[1] then playDayString = playDay;end;
		if DayTimeMoneyHud.inGameDay[1] then playDayString = inGameDay;size = DayTimeMoneyHud.inGameDay[2];color = DayTimeMoneyHud.inGameDayColor;end;
		if DayTimeMoneyHud.playDay[1] and DayTimeMoneyHud.inGameDay[1] then playDayString = playDay.. " (".. inGameDay.. ")";size = DayTimeMoneyHud.playDay[2];color = DayTimeMoneyHud.playDayColor;end;
		--local txtHeight = getTextHeight(DayTimeMoneyHud.inGameTime[2], tostring(playDayString));
		
		setTextColor(unpack(color));
		setTextBold(true);
		setTextAlignment(0);
		--renderText(DayTimeMoneyHud.inGame.overlay.x, DayTimeMoneyHud.inGame.timeTextPositionY+(txtHeight*1.5), DayTimeMoneyHud.playDay[2], tostring(playDayString));
		--renderText(DayTimeMoneyHud.inGame.overlay.x, DayTimeMoneyHud.inGame.overlay.y+DayTimeMoneyHud.inGame.overlay.height+(0.005), DayTimeMoneyHud.playDay[2], tostring(playDayString));
		renderText(DayTimeMoneyHud.inGame.weatherBox.overlay.x+(DayTimeMoneyHud.inGame.weatherBox.overlay.width/2), DayTimeMoneyHud.inGame.weatherBox.overlay.y+DayTimeMoneyHud.inGame.weatherBox.overlay.height+(0.005), size, tostring(playDayString));
								
	end;
	if DayTimeMoneyHud.realDay[1] or DayTimeMoneyHud.realTime[1] then
		local realDayTimeString = "";
		local realDay =	DayTimeMoneyHud.language[math.mod(getDate("%w"), 7)];
		local realTime = DayTimeMoneyHud:getRealTime(true, true, false);
		local size = DayTimeMoneyHud.realDay[2];
		local color = DayTimeMoneyHud.realDayColor;
		if DayTimeMoneyHud.realDay[1] then realDayTimeString = realDay;end;
		if DayTimeMoneyHud.realTime[1] then realDayTimeString = realTime;size = DayTimeMoneyHud.realTime[2];color = DayTimeMoneyHud.realTimeColor;end;
		if DayTimeMoneyHud.realDay[1] and DayTimeMoneyHud.realTime[1] then realDayTimeString = realDay.. " ".. realTime;size = DayTimeMoneyHud.realDay[2];color = DayTimeMoneyHud.realDayColor;end;
		local txtHeight = getTextHeight(size, tostring(realDayTimeString));
		setTextColor(unpack(color));
		setTextBold(true);
		setTextAlignment(0);
		renderText(DayTimeMoneyHud.inGame.weatherBox.overlay.x+(DayTimeMoneyHud.inGame.weatherBox.overlay.width/2), DayTimeMoneyHud.inGame.weatherBox.overlay.y-(txtHeight/2)-(0.005), size, tostring(realDayTimeString));
		
	end;
	--respect settings for other mods
	setTextAlignment(0);
	setTextColor(1, 1, 1, 1);
	setTextBold(false);
	--respect settings for other mods	
end;
addModEventListener(DayTimeMoneyHud);

function DayTimeMoneyHud:getProzentString(fill, capacity)	
	return string.format("%1.0f", "".. tonumber(fill)/tonumber(capacity)*100);
end;

function DayTimeMoneyHud:setGetCfg(loadCfg)
	createFolder(getUserProfileAppPath().. "modsSettings/");
	createFolder(DayTimeMoneyHud.settingsDir);
	local file = DayTimeMoneyHud.settingsDir.. "dayTimeMoneyHudSettings.xml";
	local Xml = nil;
	if not fileExists(file) or not loadCfg then
		Xml = createXMLFile("DayTimeMoneyHud_XML", file, "dayTimeMoneyHudSettings");
		local groupNameTag = ("dayTimeMoneyHudSettings.inGameDay(%d)"):format(0);
		setXMLBool(Xml, groupNameTag.. "#inGameDay", DayTimeMoneyHud.inGameDay[1]);
		setXMLFloat(Xml, groupNameTag.. "#size", DayTimeMoneyHud.inGameDay[2]);
		setXMLInt(Xml, groupNameTag.. "#pos", DayTimeMoneyHud.inGameDay[3]);
		setXMLFloat(Xml, groupNameTag.. "#colorR", DayTimeMoneyHud.inGameDayColor[1]);
		setXMLFloat(Xml, groupNameTag.. "#colorG", DayTimeMoneyHud.inGameDayColor[2]);
		setXMLFloat(Xml, groupNameTag.. "#colorB", DayTimeMoneyHud.inGameDayColor[3]);
		setXMLFloat(Xml, groupNameTag.. "#colorA", DayTimeMoneyHud.inGameDayColor[4]);
		
		groupNameTag = ("DayTimeMoneyHudSettings.playDay(%d)"):format(0);
		setXMLBool(Xml, groupNameTag.. "#playDay", DayTimeMoneyHud.playDay[1]);
		setXMLFloat(Xml, groupNameTag.. "#size", DayTimeMoneyHud.playDay[2]);
		setXMLInt(Xml, groupNameTag.. "#pos", DayTimeMoneyHud.playDay[3]);
		setXMLFloat(Xml, groupNameTag.. "#colorR", DayTimeMoneyHud.playDayColor[1]);
		setXMLFloat(Xml, groupNameTag.. "#colorG", DayTimeMoneyHud.playDayColor[2]);
		setXMLFloat(Xml, groupNameTag.. "#colorB", DayTimeMoneyHud.playDayColor[3]);
		setXMLFloat(Xml, groupNameTag.. "#colorA", DayTimeMoneyHud.playDayColor[4]);
		
		groupNameTag = ("DayTimeMoneyHudSettings.realDay(%d)"):format(0);
		setXMLBool(Xml, groupNameTag.. "#realDay", DayTimeMoneyHud.realDay[1]);
		setXMLFloat(Xml, groupNameTag.. "#size", DayTimeMoneyHud.realDay[2]);
		setXMLInt(Xml, groupNameTag.. "#pos", DayTimeMoneyHud.realDay[3]);
		setXMLFloat(Xml, groupNameTag.. "#colorR", DayTimeMoneyHud.realDayColor[1]);
		setXMLFloat(Xml, groupNameTag.. "#colorG", DayTimeMoneyHud.realDayColor[2]);
		setXMLFloat(Xml, groupNameTag.. "#colorB", DayTimeMoneyHud.realDayColor[3]);
		setXMLFloat(Xml, groupNameTag.. "#colorA", DayTimeMoneyHud.realDayColor[4]);
		
		groupNameTag = ("DayTimeMoneyHudSettings.realTime(%d)"):format(0);
		setXMLBool(Xml, groupNameTag.. "#realTime", DayTimeMoneyHud.realTime[1]);
		setXMLFloat(Xml, groupNameTag.. "#size", DayTimeMoneyHud.realTime[2]);
		setXMLInt(Xml, groupNameTag.. "#pos", DayTimeMoneyHud.realTime[3]);
		setXMLFloat(Xml, groupNameTag.. "#colorR", DayTimeMoneyHud.realTimeColor[1]);
		setXMLFloat(Xml, groupNameTag.. "#colorG", DayTimeMoneyHud.realTimeColor[2]);
		setXMLFloat(Xml, groupNameTag.. "#colorB", DayTimeMoneyHud.realTimeColor[3]);
		setXMLFloat(Xml, groupNameTag.. "#colorA", DayTimeMoneyHud.realTimeColor[4]);
		
		groupNameTag = ("DayTimeMoneyHudSettings.inGameTime(%d)"):format(0);
		setXMLBool(Xml, groupNameTag.. "#inGameTime", DayTimeMoneyHud.inGameTime[1]);
		setXMLFloat(Xml, groupNameTag.. "#size", DayTimeMoneyHud.inGameTime[2]);
		setXMLInt(Xml, groupNameTag.. "#pos", DayTimeMoneyHud.inGameTime[3]);	
		setXMLFloat(Xml, groupNameTag.. "#colorR", DayTimeMoneyHud.inGameTimeColor[1]);
		setXMLFloat(Xml, groupNameTag.. "#colorG", DayTimeMoneyHud.inGameTimeColor[2]);
		setXMLFloat(Xml, groupNameTag.. "#colorB", DayTimeMoneyHud.inGameTimeColor[3]);
		setXMLFloat(Xml, groupNameTag.. "#colorA", DayTimeMoneyHud.inGameTimeColor[4]);
		
		groupNameTag = ("DayTimeMoneyHudSettings.language(%d)"):format(0);
		setXMLString(Xml, groupNameTag.. "#weekday1", DayTimeMoneyHud.language[1]);
		setXMLString(Xml, groupNameTag.. "#weekday2", DayTimeMoneyHud.language[2]);
		setXMLString(Xml, groupNameTag.. "#weekday3", DayTimeMoneyHud.language[3]);
		setXMLString(Xml, groupNameTag.. "#weekday4", DayTimeMoneyHud.language[4]);
		setXMLString(Xml, groupNameTag.. "#weekday5", DayTimeMoneyHud.language[5]);
		setXMLString(Xml, groupNameTag.. "#weekday6", DayTimeMoneyHud.language[6]);
		setXMLString(Xml, groupNameTag.. "#weekday7", DayTimeMoneyHud.language[7]);
		setXMLString(Xml, groupNameTag.. "#playday", DayTimeMoneyHud.language[8]);
		saveXMLFile(Xml);
	else	
		Xml = loadXMLFile("DayTimeMoneyHud_XML", file, "DayTimeMoneyHudSettings");
		local groupNameTag = ("DayTimeMoneyHudSettings.inGameDay(%d)"):format(0);
		if getXMLBool(Xml, groupNameTag.. "#inGameDay") ~= nil then DayTimeMoneyHud.inGameDay[1] = getXMLBool(Xml, groupNameTag.. "#inGameDay");end;		
		if getXMLFloat(Xml, groupNameTag.. "#size") then DayTimeMoneyHud.inGameDay[2] = getXMLFloat(Xml, groupNameTag.. "#size");end;
		if getXMLInt(Xml, groupNameTag.. "#pos") then DayTimeMoneyHud.inGameDay[3] = getXMLFloat(Xml, groupNameTag.. "#pos");end;
		if getXMLFloat(Xml, groupNameTag.. "#colorR") then DayTimeMoneyHud.inGameDayColor[1] = getXMLFloat(Xml, groupNameTag.. "#colorR");end;
		if getXMLFloat(Xml, groupNameTag.. "#colorG") then DayTimeMoneyHud.inGameDayColor[2] = getXMLFloat(Xml, groupNameTag.. "#colorG");end;
		if getXMLFloat(Xml, groupNameTag.. "#colorB") then DayTimeMoneyHud.inGameDayColor[3] = getXMLFloat(Xml, groupNameTag.. "#colorB");end;
		if getXMLFloat(Xml, groupNameTag.. "#colorA") then DayTimeMoneyHud.inGameDayColor[4] = getXMLFloat(Xml, groupNameTag.. "#colorA");end;
		
		groupNameTag = ("DayTimeMoneyHudSettings.playDay(%d)"):format(0);
		if getXMLBool(Xml, groupNameTag.. "#playDay") ~= nil then DayTimeMoneyHud.playDay[1] = getXMLBool(Xml, groupNameTag.. "#playDay");end;
		if getXMLFloat(Xml, groupNameTag.. "#size") then DayTimeMoneyHud.playDay[2] = getXMLFloat(Xml, groupNameTag.. "#size");end;
		if getXMLInt(Xml, groupNameTag.. "#pos") then DayTimeMoneyHud.playDay[3] = getXMLFloat(Xml, groupNameTag.. "#pos");end;
		if getXMLFloat(Xml, groupNameTag.. "#colorR") then DayTimeMoneyHud.playDayColor[1] = getXMLFloat(Xml, groupNameTag.. "#colorR");end;
		if getXMLFloat(Xml, groupNameTag.. "#colorG") then DayTimeMoneyHud.playDayColor[2] = getXMLFloat(Xml, groupNameTag.. "#colorG");end;
		if getXMLFloat(Xml, groupNameTag.. "#colorB") then DayTimeMoneyHud.playDayColor[3] = getXMLFloat(Xml, groupNameTag.. "#colorB");end;
		if getXMLFloat(Xml, groupNameTag.. "#colorA") then DayTimeMoneyHud.playDayColor[4] = getXMLFloat(Xml, groupNameTag.. "#colorA");end;
		
		
		groupNameTag = ("DayTimeMoneyHudSettings.realDay(%d)"):format(0);
		if getXMLBool(Xml, groupNameTag.. "#realDay") ~= nil then DayTimeMoneyHud.realDay[1] = getXMLBool(Xml, groupNameTag.. "#realDay");end;
		if getXMLFloat(Xml, groupNameTag.. "#size") then DayTimeMoneyHud.realDay[2] = getXMLFloat(Xml, groupNameTag.. "#size");end;
		if getXMLInt(Xml, groupNameTag.. "#pos") then DayTimeMoneyHud.realDay[3] = getXMLFloat(Xml, groupNameTag.. "#pos");end;
		if getXMLFloat(Xml, groupNameTag.. "#colorR") then DayTimeMoneyHud.realDayColor[1] = getXMLFloat(Xml, groupNameTag.. "#colorR");end;
		if getXMLFloat(Xml, groupNameTag.. "#colorG") then DayTimeMoneyHud.realDayColor[2] = getXMLFloat(Xml, groupNameTag.. "#colorG");end;
		if getXMLFloat(Xml, groupNameTag.. "#colorB") then DayTimeMoneyHud.realDayColor[3] = getXMLFloat(Xml, groupNameTag.. "#colorB");end;
		if getXMLFloat(Xml, groupNameTag.. "#colorA") then DayTimeMoneyHud.realDayColor[4] = getXMLFloat(Xml, groupNameTag.. "#colorA");end;
		
		groupNameTag = ("DayTimeMoneyHudSettings.realTime(%d)"):format(0);
		if getXMLBool(Xml, groupNameTag.. "#realTime") ~= nil then DayTimeMoneyHud.realTime[1] = getXMLBool(Xml, groupNameTag.. "#realTime");end;
		if getXMLFloat(Xml, groupNameTag.. "#size") then DayTimeMoneyHud.realTime[2] = getXMLFloat(Xml, groupNameTag.. "#size");end;
		if getXMLInt(Xml, groupNameTag.. "#pos") then DayTimeMoneyHud.realTime[3] = getXMLFloat(Xml, groupNameTag.. "#pos");end;
		if getXMLFloat(Xml, groupNameTag.. "#colorR") then DayTimeMoneyHud.realTimeColor[1] = getXMLFloat(Xml, groupNameTag.. "#colorR");end;
		if getXMLFloat(Xml, groupNameTag.. "#colorG") then DayTimeMoneyHud.realTimeColor[2] = getXMLFloat(Xml, groupNameTag.. "#colorG");end;
		if getXMLFloat(Xml, groupNameTag.. "#colorB") then DayTimeMoneyHud.realTimeColor[3] = getXMLFloat(Xml, groupNameTag.. "#colorB");end;
		if getXMLFloat(Xml, groupNameTag.. "#colorA") then DayTimeMoneyHud.realTimeColor[4] = getXMLFloat(Xml, groupNameTag.. "#colorA");end;
		
		groupNameTag = ("DayTimeMoneyHudSettings.inGameTime(%d)"):format(0);
		if getXMLBool(Xml, groupNameTag.. "#inGameTime") ~= nil then DayTimeMoneyHud.inGameTime[1] = getXMLBool(Xml, groupNameTag.. "#inGameTime");end;		
		if getXMLFloat(Xml, groupNameTag.. "#size") then DayTimeMoneyHud.inGameTime[2] = getXMLFloat(Xml, groupNameTag.. "#size");end;
		if getXMLInt(Xml, groupNameTag.. "#pos") then DayTimeMoneyHud.inGameTime[3] = getXMLFloat(Xml, groupNameTag.. "#pos");end;
		if getXMLFloat(Xml, groupNameTag.. "#colorR") then DayTimeMoneyHud.inGameTimeColor[1] = getXMLFloat(Xml, groupNameTag.. "#colorR");end;
		if getXMLFloat(Xml, groupNameTag.. "#colorG") then DayTimeMoneyHud.inGameTimeColor[2] = getXMLFloat(Xml, groupNameTag.. "#colorG");end;
		if getXMLFloat(Xml, groupNameTag.. "#colorB") then DayTimeMoneyHud.inGameTimeColor[3] = getXMLFloat(Xml, groupNameTag.. "#colorB");end;
		if getXMLFloat(Xml, groupNameTag.. "#colorA") then DayTimeMoneyHud.inGameTimeColor[4] = getXMLFloat(Xml, groupNameTag.. "#colorA");end;
		
		groupNameTag = ("DayTimeMoneyHudSettings.language(%d)"):format(0);
		if getXMLString(Xml, groupNameTag.. "#weekday1") ~= nil then DayTimeMoneyHud.language[1] = getXMLString(Xml, groupNameTag.. "#weekday1");end;
		if getXMLString(Xml, groupNameTag.. "#weekday2") ~= nil then DayTimeMoneyHud.language[2] = getXMLString(Xml, groupNameTag.. "#weekday2");end;
		if getXMLString(Xml, groupNameTag.. "#weekday3") ~= nil then DayTimeMoneyHud.language[3] = getXMLString(Xml, groupNameTag.. "#weekday3");end;
		if getXMLString(Xml, groupNameTag.. "#weekday4") ~= nil then DayTimeMoneyHud.language[4] = getXMLString(Xml, groupNameTag.. "#weekday4");end;
		if getXMLString(Xml, groupNameTag.. "#weekday5") ~= nil then DayTimeMoneyHud.language[5] = getXMLString(Xml, groupNameTag.. "#weekday5");end;
		if getXMLString(Xml, groupNameTag.. "#weekday6") ~= nil then DayTimeMoneyHud.language[6] = getXMLString(Xml, groupNameTag.. "#weekday6");end;
		if getXMLString(Xml, groupNameTag.. "#weekday7") ~= nil then DayTimeMoneyHud.language[7] = getXMLString(Xml, groupNameTag.. "#weekday7");end;
		if getXMLString(Xml, groupNameTag.. "#playday") ~= nil then DayTimeMoneyHud.language[8] = getXMLString(Xml, groupNameTag.. "#playday");end;
	end;	
end;

function DayTimeMoneyHud:getOptimalSize(width, txtString, defaultSize)
	local length = getTextWidth(defaultSize, tostring(txtString));
	local default = defaultSize;
	if length > width then
		local i = 0;
		while length > width do
			i = i + 0.0005;
			length = getTextWidth(defaultSize-i, tostring(txtString));
		end
		return defaultSize-i;
	end;
	return default;
end;

function DayTimeMoneyHud:getRealTime(getHours, getMin, getSec)
	if getHours and not getMin and not getSec then return tostring(getDate("%H"));end;
	if getHours and getMin and not getSec then return tostring(getDate("%H:%M"));end;
	if getHours and getMin and getSec then return tostring(getDate("%H:%M:%S"));end;
	return "0";
end;

function DayTimeMoneyHud:getInGameDay(currentDay, weekday)	
	if currentDay and not weekday then return Utils.getNoNil(g_currentMission.environment.currentDay, 1);end;
	if not currentDay and weekday then return math.mod(g_currentMission.environment.currentDay, 7);end;
	if currentDay and weekday then return Utils.getNoNil(g_currentMission.environment.currentDay, 1), math.mod(g_currentMission.environment.currentDay, 7);end;
	return 0, 0;
end;

function DayTimeMoneyHud:getInGameDisplay()
	for key, value in pairs(g_currentMission.hud.displayComponents) do
		if g_currentMission.hud.displayComponents[key].showTime ~= nil then
			DayTimeMoneyHud.inGame = g_currentMission.hud.displayComponents[key];
			break;
		end;
	end;
end;				